diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
index a93cc2f38..99ea24a7b 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
@@ -21,13 +21,13 @@ public class ItemBlockLadder<T extends BlockLogicLadder> extends ItemBlock<T> {
     @Override
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         TilePos bp = new TilePos(blockPos);
-        Block<?> clickedBlock = world.getBlock(bp);
+        Block<?> clickedBlock = world.getBlockType(bp);
 
         BlockLogicLadder ladder = this.block.getLogic();
 
         if (clickedBlock == this.block && player != null && !player.isSneaking()) {
             Side clickedLadderSide = ladder.getSideFromMeta(world.getBlockData(bp));
-            while (world.getBlock(bp) == this.block && ladder.getSideFromMeta(world.getBlockData(bp)) == clickedLadderSide)
+            while (world.getBlockType(bp) == this.block && ladder.getSideFromMeta(world.getBlockData(bp)) == clickedLadderSide)
                 bp.y--;
             int meta = ladder.getMetaForSide(clickedLadderSide);
             if (ladder.canExistAt(world, new TilePos(bp), meta)) {
@@ -55,15 +55,15 @@ public class ItemBlockLadder<T extends BlockLogicLadder> extends ItemBlock<T> {
     }
 
 
-    public boolean placeBlock(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TilePos blockPos, int meta, @Nullable Player player, @NotNull Side side, double xHit, double yHit) {
-        if (world.canPlaceInsideBlock(blockPos) && world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side) && selfStack.consumeItem(player)) {
-            if (world.setBlockIdDataNotify(blockPos, this.block.id(), meta)) {
+    public boolean placeBlock(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TilePos tilePos, int meta, @Nullable Player player, @NotNull Side side, double xHit, double yHit) {
+        if (world.canPlaceInsideBlock(tilePos) && world.canBlockIdBePlacedAt(this.block.id(), tilePos, false, side) && selfStack.consumeItem(player)) {
+            if (world.setBlockTypeDataNotify(tilePos, this.block, meta)) {
                 if (player == null) {
-                    this.block.onPlacedOnSide(world, blockPos, side, xHit, yHit);
+                    this.block.onPlacedOnSide(world, tilePos, side, xHit, yHit);
                 } else {
-                    this.block.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
+                    this.block.onPlacedByMob(world, tilePos, side, player, xHit, yHit);
                 }
-                world.playBlockSoundEffect(player, blockPos.x + 0.5f, blockPos.y + 0.5f, blockPos.z + 0.5f, this.block, EnumBlockSoundEffectType.PLACE);
+                world.playBlockSoundEffect(player, tilePos.x + 0.5f, tilePos.y + 0.5f, tilePos.z + 0.5f, this.block, EnumBlockSoundEffectType.PLACE);
                 return true;
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
index 1f4d42ba5..b5c06c363 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
@@ -22,14 +22,14 @@ public class ItemBlockLayer<T extends BlockLogicLayerBase> extends ItemBlock<T>
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        Block<?> targetBlock = world.getBlock(blockPos);
-        int meta = world.getBlockData(blockPos);
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
+        Block<?> targetBlock = world.getBlockType(tilePos);
+        int meta = world.getBlockData(tilePos);
         if (targetBlock != this.block && targetBlock != null && targetBlock.hasTag(BlockTags.PLACE_OVERWRITES)) {
             targetBlock = null;
             meta = 0;
         }
-        if (selfStack.stackSize <= 0 || blockPos.y() == world.getHeightBlocks() - 1 && this.block.getMaterial().isSolid()) {
+        if (selfStack.stackSize <= 0 || tilePos.y() == world.getHeightBlocks() - 1 && this.block.getMaterial().isSolid()) {
             return false;
         }
 
@@ -38,21 +38,21 @@ public class ItemBlockLayer<T extends BlockLogicLayerBase> extends ItemBlock<T>
             final BlockLogicLayerBase blockLayer = this.block.getLogic();
             final int newMeta = meta + 1;
 
-            final AABBdc bbBox = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1f, blockPos.y() + (2 * (newMeta + 1)) / 16.0f, blockPos.z() + 1f);
+            final AABBdc bbBox = new AABBd(tilePos.x(), tilePos.y(), tilePos.z(), tilePos.x() + 1f, tilePos.y() + (2 * (newMeta + 1)) / 16.0f, tilePos.z() + 1f);
             if (!world.checkIfAABBIsClear(bbBox)) {
                 return false;
             }
 
             if (newMeta < 7) {
-                world.setBlockIdDataNotify(blockPos, this.block.id(), newMeta);
+                world.setBlockTypeDataNotify(tilePos, this.block, newMeta);
             } else {
                 if (blockLayer.fullBlock != null) {
-                    world.setBlockIdDataNotify(blockPos, blockLayer.fullBlock.id(), 0);
+                    world.setBlockTypeNotify(tilePos, blockLayer.fullBlock);
                 } else {
-                    world.setBlockIdDataNotify(blockPos.up(new TilePos()), this.block.id(), 0);
+                    world.setBlockTypeNotify(tilePos.up(new TilePos()), this.block);
                 }
             }
-            world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
+            world.playBlockSoundEffect(player, tilePos.x() + 0.5F, tilePos.y() + 0.5F, tilePos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
             selfStack.consumeItem(player);
             return true;
 
@@ -60,9 +60,9 @@ public class ItemBlockLayer<T extends BlockLogicLayerBase> extends ItemBlock<T>
 
         // Offset position
         if (targetBlock != null) {
-            blockPos = blockPos.add(side.getDirection(), new TilePos());
-            targetBlock = world.getBlock(blockPos);
-            meta = world.getBlockData(blockPos);
+            tilePos = tilePos.add(side.getDirection(), new TilePos());
+            targetBlock = world.getBlockType(tilePos);
+            meta = world.getBlockData(tilePos);
         }
 
         // Check if the block we're placing into is a layer
@@ -70,35 +70,35 @@ public class ItemBlockLayer<T extends BlockLogicLayerBase> extends ItemBlock<T>
             final BlockLogicLayerBase blockLayer = this.block.getLogic();
             final int newMeta = meta + 1;
 
-            final AABBdc bbBox = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1f, blockPos.y() + (2 * (newMeta + 1)) / 16.0f, blockPos.z() + 1f);
+            final AABBdc bbBox = new AABBd(tilePos.x(), tilePos.y(), tilePos.z(), tilePos.x() + 1f, tilePos.y() + (2 * (newMeta + 1)) / 16.0f, tilePos.z() + 1f);
             if (!world.checkIfAABBIsClear(bbBox)) {
                 return false;
             }
 
             if (newMeta < 7) {
-                world.setBlockIdDataNotify(blockPos, this.block.id(), newMeta);
+                world.setBlockTypeDataNotify(tilePos, this.block, newMeta);
             } else {
                 if (blockLayer.fullBlock != null) {
-                    world.setBlockIdDataNotify(blockPos, blockLayer.fullBlock.id(), 0);
+                    world.setBlockTypeNotify(tilePos, blockLayer.fullBlock);
                 } else {
-                    world.setBlockIdDataNotify(blockPos.up(new TilePos()), this.block.id(), 0);
+                    world.setBlockTypeNotify(tilePos.up(new TilePos()), this.block);
                 }
             }
-            world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
+            world.playBlockSoundEffect(player, tilePos.x() + 0.5F, tilePos.y() + 0.5F, tilePos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
             selfStack.consumeItem(player);
             return true;
         }
 
         // Regular placement, as all else fails
-        if (world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side)) {
-            int placeMeta = getPlacedData(selfStack, world, player, blockPos, side, xHit, yHit);
-            if (world.setBlockIdDataNotify(blockPos, this.block.id(), placeMeta)) {
+        if (world.canBlockIdBePlacedAt(this.block.id(), tilePos, false, side)) {
+            int placeMeta = getPlacedData(selfStack, world, player, tilePos, side, xHit, yHit);
+            if (world.setBlockTypeDataNotify(tilePos, this.block, placeMeta)) {
                 if (player == null) {
-                    this.block.onPlacedOnSide(world, blockPos, side, xHit, yHit);
+                    this.block.onPlacedOnSide(world, tilePos, side, xHit, yHit);
                 } else {
-                    this.block.onPlacedByMob(world, blockPos, Side.NONE, player, xHit, yHit);
+                    this.block.onPlacedByMob(world, tilePos, Side.NONE, player, xHit, yHit);
                 }
-                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
+                world.playBlockSoundEffect(player, tilePos.x() + 0.5F, tilePos.y() + 0.5F, tilePos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
                 selfStack.consumeItem(player);
                 return true;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
index 6398d1648..7761fa869 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
@@ -24,7 +24,7 @@ public class ItemBlockLayerLeaves<T extends BlockLogicLayerLeaves> extends ItemB
 
     @Override
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        Block<?> targetBlock = world.getBlock(blockPos);
+        Block<?> targetBlock = world.getBlockType(blockPos);
         int meta = world.getBlockData(blockPos);
         if (targetBlock != this.block && targetBlock != null && targetBlock.hasTag(BlockTags.PLACE_OVERWRITES)) {
             targetBlock = null;
@@ -45,12 +45,12 @@ public class ItemBlockLayerLeaves<T extends BlockLogicLayerLeaves> extends ItemB
             }
 
             if ((newMeta & 0b00001111) < 7) {
-                world.setBlockIdDataNotify(blockPos, this.block.id(), BlockLogicLayerLeaves.setPermanent(newMeta, true));
+                world.setBlockTypeDataNotify(blockPos, this.block, BlockLogicLayerLeaves.setPermanent(newMeta, true));
             } else {
                 if (blockLayer.fullBlock != null) {
-                    world.setBlockIdDataNotify(blockPos, blockLayer.fullBlock.id(), BlockLogicLeavesBase.setPermanent(0, true));
+                    world.setBlockTypeDataNotify(blockPos, blockLayer.fullBlock, BlockLogicLeavesBase.setPermanent(0, true));
                 } else {
-                    world.setBlockIdDataNotify(blockPos.up(new TilePos()), this.block.id(), BlockLogicLayerLeaves.setPermanent(0, true));
+                    world.setBlockTypeDataNotify(blockPos.up(new TilePos()), this.block, BlockLogicLayerLeaves.setPermanent(0, true));
                 }
             }
             world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
@@ -61,7 +61,7 @@ public class ItemBlockLayerLeaves<T extends BlockLogicLayerLeaves> extends ItemB
         // Offset position
         if (targetBlock != null) {
             blockPos = blockPos.add(side.getDirection(), new TilePos());
-            targetBlock = world.getBlock(blockPos);
+            targetBlock = world.getBlockType(blockPos);
             meta = world.getBlockData(blockPos);
         }
 
@@ -76,12 +76,12 @@ public class ItemBlockLayerLeaves<T extends BlockLogicLayerLeaves> extends ItemB
             }
 
             if ((newMeta & 0b00001111) < 7) {
-                world.setBlockIdDataNotify(blockPos, this.block.id(), BlockLogicLayerLeaves.setPermanent(newMeta, true));
+                world.setBlockTypeDataNotify(blockPos, this.block, BlockLogicLayerLeaves.setPermanent(newMeta, true));
             } else {
                 if (blockLayer.fullBlock != null) {
-                    world.setBlockIdDataNotify(blockPos, blockLayer.fullBlock.id(), BlockLogicLeavesBase.setPermanent(0, true));
+                    world.setBlockTypeDataNotify(blockPos, blockLayer.fullBlock, BlockLogicLeavesBase.setPermanent(0, true));
                 } else {
-                    world.setBlockIdDataNotify(blockPos.up(new TilePos()), this.block.id(), BlockLogicLayerLeaves.setPermanent(0, true));
+                    world.setBlockTypeDataNotify(blockPos.up(new TilePos()), this.block, BlockLogicLayerLeaves.setPermanent(0, true));
                 }
             }
             world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
@@ -92,7 +92,7 @@ public class ItemBlockLayerLeaves<T extends BlockLogicLayerLeaves> extends ItemB
         // Regular placement, as all else fails
         if (world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side)) {
             int placeMeta = getPlacedData(selfStack, world, player, blockPos, side, xHit, yHit);
-            if (world.setBlockIdDataNotify(blockPos, this.block.id(), placeMeta)) {
+            if (world.setBlockTypeDataNotify(blockPos, this.block, placeMeta)) {
                 if (player == null) {
                     this.block.onPlacedOnSide(world, blockPos, side, xHit, yHit);
                 } else {
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
index 31bce15cd..009657755 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
@@ -23,11 +23,11 @@ public class ItemBlockSlab<T extends BlockLogic> extends ItemBlock<T> {
 
     @Override
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        int id = world.getBlockId(blockPos);
+        @NotNull Block<?> block = world.getBlockType(blockPos);
         int meta = world.getBlockData(blockPos) & 0b11;
         int otherMeta = world.getBlockData(blockPos) & ~0b11;
-        if (Blocks.blocksList[world.getBlockId(blockPos)] != null && Blocks.blocksList[world.getBlockId(blockPos)].hasTag(BlockTags.PLACE_OVERWRITES)) {
-            id = 0;
+        if (world.getBlockType(blockPos).hasTag(BlockTags.PLACE_OVERWRITES)) {
+            block = Blocks.AIR;
             meta = 0;
         }
         if (selfStack.stackSize <= 0 || blockPos.y() == world.getHeightBlocks() - 1 && this.block.getMaterial().isSolid()) {
@@ -35,7 +35,7 @@ public class ItemBlockSlab<T extends BlockLogic> extends ItemBlock<T> {
         }
 
         // Check if we're placing "inside" a slab
-        if (id == this.block.id() && otherMeta == selfStack.getMetadata() && (side == Side.TOP || side == Side.BOTTOM)) {
+        if (block == this.block && otherMeta == selfStack.getMetadata() && (side == Side.TOP || side == Side.BOTTOM)) {
             if ((side == Side.TOP && meta == 0) || (side == Side.BOTTOM && meta == 2)) {
                 AABBdc bbBox = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1f, blockPos.y() + 1f, blockPos.z() + 1f);
                 if (!world.checkIfAABBIsClear(bbBox)) {
@@ -50,15 +50,15 @@ public class ItemBlockSlab<T extends BlockLogic> extends ItemBlock<T> {
         }
 
         // Offset position
-        if (id != 0) {
+        if (block != Blocks.AIR) {
             blockPos = blockPos.add(side.getDirection(), new TilePos());
-            id = world.getBlockId(blockPos);
+            block = world.getBlockType(blockPos);
             meta = world.getBlockData(blockPos) & 0b11;
             otherMeta = world.getBlockData(blockPos) & ~0b11;
         }
 
         // Check if the block we're placing into is a slab
-        if (id == this.block.id() && otherMeta == selfStack.getMetadata()) {
+        if (block == this.block && otherMeta == selfStack.getMetadata()) {
             if ((yHit > 0.5f && meta == 0) || (yHit <= 0.5f && meta == 2) || (side == Side.BOTTOM && meta == 0) || (side == Side.TOP && meta == 2)) {
                 AABBdc bbBox = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1f, blockPos.y() + 1f, blockPos.z() + 1f);
                 if (!world.checkIfAABBIsClear(bbBox)) {
@@ -75,7 +75,7 @@ public class ItemBlockSlab<T extends BlockLogic> extends ItemBlock<T> {
         // Regular placement, as all else fails
         if (world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side)) {
             int placeMeta = getPlacedData(selfStack, world, player, blockPos, side, xHit, yHit);
-            if (world.setBlockIdDataNotify(blockPos, this.block.id(), placeMeta)) {
+            if (world.setBlockTypeDataNotify(blockPos, this.block, placeMeta)) {
                 if (player == null) {
                     this.block.onPlacedOnSide(world, blockPos, side, xHit, yHit);
                 } else {
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemTool.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemTool.java
index f6e0810b9..b2fac0e0c 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemTool.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemTool.java
@@ -10,7 +10,7 @@ import net.minecraft.core.item.material.ToolMaterial;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class ItemTool extends Item {
@@ -45,7 +45,7 @@ public class ItemTool extends Item {
 	}
 
 	@Override
-	public boolean onBlockDestroyed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Mob mob, @NotNull Block<?> removedBlock, @NotNull TilePos blockPos, @NotNull Side side) {
+	public boolean onBlockDestroyed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Mob mob, @NotNull Block<?> removedBlock, @NotNull TilePosc blockPos, @NotNull Side side) {
         if (removedBlock.getHardness() > 0.0f || isSilkTouch()) {
             selfStack.damageItem(1, mob);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolAxe.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolAxe.java
index 759592bab..5b9f4d115 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolAxe.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolAxe.java
@@ -2,7 +2,6 @@ package net.minecraft.core.item.tool;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicLog;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.data.gamerule.TreecapitatorHelper;
@@ -12,7 +11,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ToolMaterial;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class ItemToolAxe extends ItemTool {
@@ -27,11 +26,11 @@ public class ItemToolAxe extends ItemTool {
     }
 
     @Override
-    public boolean beforeBlockDestroyed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Player player, @NotNull Block<?> block, @NotNull TilePos blockPos, @NotNull Side side) {
+    public boolean beforeBlockDestroyed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Player player, @NotNull Block<?> block, @NotNull TilePosc blockPos, @NotNull Side side) {
         if(!world.isClientSide && world.getGameRuleValue(GameRules.TREECAPITATOR) && !player.isSneaking()) {
-            int id = world.getBlockId(blockPos);
-            if(Block.hasLogicClass(Blocks.getBlock(id), BlockLogicLog.class)) {
-                return !new TreecapitatorHelper(world, blockPos.x, blockPos.y, blockPos.z, player).chopTree();
+            final @NotNull Block<?> blockType = world.getBlockType(blockPos);
+            if(Block.hasLogicClass(blockType, BlockLogicLog.class)) {
+                return !new TreecapitatorHelper(world, blockPos.x(), blockPos.y(), blockPos.z(), player).chopTree();
             }
         }
         return true;
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
index e6d2444eb..7034c6fa5 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
@@ -43,23 +43,23 @@ public class ItemToolHoe extends ItemTool {
     }
 
     public boolean till(@NotNull ItemStack selfStack, @Nullable Player player, @NotNull World world, @NotNull TilePosc blockPos, @NotNull Side side) {
-        int id = world.getBlockId(blockPos);
-        int idAbove = world.getBlockId(blockPos.up(new TilePos()));
-        if (side != Side.BOTTOM && idAbove == 0 && (id == Blocks.GRASS.id() || id == Blocks.DIRT.id() || id == Blocks.PATH_DIRT.id() || id == Blocks.GRASS_RETRO.id() || id == Blocks.MUD.id())) {
+        final @NotNull Block<?> block = world.getBlockType(blockPos);
+        final @NotNull Block<?> blockAbove = world.getBlockType(blockPos.up(new TilePos()));
+        if (side != Side.BOTTOM && blockAbove == Blocks.AIR && (block == Blocks.GRASS || block == Blocks.DIRT || block == Blocks.PATH_DIRT || block == Blocks.GRASS_RETRO || block == Blocks.MUD)) {
             int meta = 0;
-            if (id == Blocks.MUD.id()) {
+            if (block == Blocks.MUD) {
                 meta = 1;
             }
             world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.DIRT, EnumBlockSoundEffectType.MINE);
             if (!world.isClientSide) {
-                if (id == Blocks.GRASS.id() || id == Blocks.GRASS_RETRO.id() || id == Blocks.GRASS_SCORCHED.id()) {
+                if (block == Blocks.GRASS || block == Blocks.GRASS_RETRO || block == Blocks.GRASS_SCORCHED) {
                     if (world.rand.nextInt(5) == 0) {
                         world.dropItem(blockPos.up(new TilePos()), new ItemStack(Items.SEEDS_WHEAT));
                     }
                 }
             }
             if (!world.isClientSide) {
-                world.setBlockIdDataNotify(blockPos, Blocks.FARMLAND_DIRT.id(), meta);
+                world.setBlockTypeDataNotify(blockPos, Blocks.FARMLAND_DIRT, meta);
                 selfStack.damageItem(1, player);
             }
             return true;
@@ -68,7 +68,7 @@ public class ItemToolHoe extends ItemTool {
     }
 
     @Override
-    public boolean onBlockDestroyed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Mob mob, @NotNull Block<?> removedBlock, @NotNull TilePos blockPos, @NotNull Side side) {
+    public boolean onBlockDestroyed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Mob mob, @NotNull Block<?> removedBlock, @NotNull TilePosc blockPos, @NotNull Side side) {
         if (!world.isClientSide) {
             if (removedBlock == Blocks.TALLGRASS || removedBlock == Blocks.TALLGRASS_FERN) {
                 if (this.material.isSilkTouch()) {
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
index 584313013..895b76bff 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
@@ -40,12 +40,12 @@ public class ItemToolShovel extends ItemTool {
     }
 
     public boolean shovelBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player entityplayer, @NotNull TilePosc blockPos, @NotNull Side side) {
-        int blockId = world.getBlockId(blockPos);
-        int blockAbove = world.getBlockId(blockPos.up(new TilePos()));
-        if (side != Side.BOTTOM && blockAbove == 0 && (blockId == Blocks.GRASS.id() || blockId == Blocks.DIRT.id() || blockId == Blocks.GRASS_RETRO.id() || blockId == Blocks.FARMLAND_DIRT.id())) {
-            world.playBlockSoundEffect(entityplayer, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.blocksList[blockId], EnumBlockSoundEffectType.PLACE);
+        final @NotNull Block<?> block = world.getBlockType(blockPos);
+        final @NotNull Block<?> blockAbove = world.getBlockType(blockPos.up(new TilePos()));
+        if (side != Side.BOTTOM && blockAbove == Blocks.AIR && (block == Blocks.GRASS || block == Blocks.DIRT || block == Blocks.GRASS_RETRO || block == Blocks.FARMLAND_DIRT)) {
+            world.playBlockSoundEffect(entityplayer, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, block, EnumBlockSoundEffectType.PLACE);
             if (!world.isClientSide) {
-                world.setBlockIdNotify(blockPos, Blocks.PATH_DIRT.id());
+                world.setBlockTypeNotify(blockPos, Blocks.PATH_DIRT);
                 selfStack.damageItem(1, entityplayer);
             }
             return true;
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
index b4c75d12c..3d99468b8 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
@@ -43,7 +43,7 @@ public class ItemToolSword extends Item
     }
 
     @Override
-    public boolean onBlockDestroyed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Mob mob, @NotNull Block<?> removedBlock, @NotNull TilePos blockPos, @NotNull Side side) {
+    public boolean onBlockDestroyed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Mob mob, @NotNull Block<?> removedBlock, @NotNull TilePosc blockPos, @NotNull Side side) {
         if (removedBlock.getHardness() > 0.0f || isSilkTouch()) {
             selfStack.damageItem(2, mob);
         }
@@ -53,9 +53,9 @@ public class ItemToolSword extends Item
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
         blockPos = blockPos.add(direction, new TilePos());
-        Block<?> b = world.getBlock(blockPos);
+        Block<?> b = world.getBlockType(blockPos);
         if (b == Blocks.PUMPKIN) {
-            world.setBlockIdData(blockPos, Blocks.PUMPKIN_CARVED_IDLE.id(), direction.getOpposite().getId());
+            world.setBlockTypeData(blockPos, Blocks.PUMPKIN_CARVED_IDLE, direction.getOpposite().getId());
             selfStack.damageItem(1, null);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketUseOrPlaceItemStack.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketUseOrPlaceItemStack.java
index f13abb824..21c0c9a58 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketUseOrPlaceItemStack.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketUseOrPlaceItemStack.java
@@ -7,6 +7,7 @@ import java.io.IOException;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.util.helper.Direction;
+import org.jetbrains.annotations.Nullable;
 
 public class PacketUseOrPlaceItemStack extends Packet
 {
@@ -60,7 +61,7 @@ public class PacketUseOrPlaceItemStack extends Packet
     {
     }
 
-    public PacketUseOrPlaceItemStack(int x, int y, int z, Direction direction, ItemStack itemstack, double xPlaced, double yPlaced, byte type)
+    public PacketUseOrPlaceItemStack(int x, int y, int z, Direction direction, @Nullable ItemStack itemstack, double xPlaced, double yPlaced, byte type)
     {
         xPosition = x;
         yPosition = y;
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
index a4c6ddfc1..ba98d5c82 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
@@ -85,26 +85,28 @@ public class ContainerInventory
         }
     }
 
-    public int setCurrentItem(final @NotNull ItemStack stack) {
+    public int setCurrentItem(final @Nullable ItemStack stack) {
         if (this.currentSlotLocked()) {
             return this.currentSlot;
         }
 
-        if (stack.itemID < Blocks.blocksList.length) {
-            if (Objects.requireNonNull(Blocks.blocksList[stack.itemID]).hasTag(BlockTags.NOT_IN_CREATIVE_MENU)) {
-                return this.currentSlot;
-            }
-        } else {
-            if (Objects.requireNonNull(Item.itemsList[stack.itemID]).hasTag(ItemTags.NOT_IN_CREATIVE_MENU)) {
-                return this.currentSlot;
+        if (stack != null) {
+            if (stack.itemID < Blocks.blocksList.length) {
+                if (Objects.requireNonNull(Blocks.blocksList[stack.itemID]).hasTag(BlockTags.NOT_IN_CREATIVE_MENU)) {
+                    return this.currentSlot;
+                }
+            } else {
+                if (Objects.requireNonNull(Item.itemsList[stack.itemID]).hasTag(ItemTags.NOT_IN_CREATIVE_MENU)) {
+                    return this.currentSlot;
+                }
             }
-        }
 
-        for (int i = this.hotbarOffset; i < this.hotbarOffset + HOTBAR_SIZE; i++) {
-            final @Nullable ItemStack hotbarStack = this.mainInventory[i];
-            if (hotbarStack != null && hotbarStack.itemID == stack.itemID) {
-                this.currentSlot = i;
-                return this.currentSlot;
+            for (int i = this.hotbarOffset; i < this.hotbarOffset + HOTBAR_SIZE; i++) {
+                final @Nullable ItemStack hotbarStack = this.mainInventory[i];
+                if (hotbarStack != null && hotbarStack.itemID == stack.itemID) {
+                    this.currentSlot = i;
+                    return this.currentSlot;
+                }
             }
         }
 
